Robot Simulator of the Robotics Group for Self-Organization of Control: RobotChain Class Reference

# RobotChain Class Reference

Chain of robots. More...

`#include <robotchain.h>`

Inherits lpzrobots::OdeRobot.

Collaboration diagram for RobotChain:
[legend]

List of all members.

## Public Member Functions
| RobotChain (const OdeHandle &odeHandle, const OsgHandle &osgHandle, const RobotChainConf &conf, const std::string &name)
| constructor of uwo robot
virtual | ~RobotChain ()
virtual void | update ()
| updates the OSG nodes of the vehicle
virtual void | place (const osg::Matrix &pose)
| sets the pose of the vehicle
virtual int | getSensors (sensor *sensors, int sensornumber)
| returns actual sensorvalues
virtual void | setMotors (const motor *motors, int motornumber)
| sets actual motorcommands
virtual int | getSensorNumber ()
| returns number of sensors
virtual int | getMotorNumber ()
| returns number of motors
virtual void | doInternalStuff (GlobalData &globalData)
| this function is called in each simulation timestep (always after control).
virtual void | notifyOnChange (const paramkey &key)
| Is called when a parameter was changes via setParam().
virtual int | getIRSensorNum ()
## Static Public Member Functions
static RobotChainConf | getDefaultConf ()
## Protected Member Functions
virtual Primitive * | getMainPrimitive () const
| return the primitive of the robot that is used for tracking and camera following
virtual void | create (const osg::Matrix &pose)
virtual void | destroy ()
| destroys vehicle and space
## Protected Attributes
RobotChainConf | conf
bool | created
std::vector< OdeRobot * > | robots

## Detailed Description

Chain of robots.

## Constructor & Destructor Documentation

RobotChain | ( | const OdeHandle & | odeHandle,
|  | const OsgHandle & | osgHandle,
|  | const RobotChainConf & | conf,
|  | const std::string & | name |
| ) |  |  |

constructor of uwo robot

Parameters:

  | odeHandle | data structure for accessing ODE
  | osgHandle | ata structure for accessing OSG
  | size | scaling of robot
  | force | maximal used force to realize motorcommand
  | radialLegs | switches between cartensian and radial leg joints

virtual ~RobotChain | ( |  | ) | `[inline, virtual]`

## Member Function Documentation

void create | ( | const osg::Matrix & | pose | ) | `[protected, virtual]`

void destroy | ( |  | ) | `[protected, virtual]`

destroys vehicle and space

void doInternalStuff | ( | GlobalData & | globalData | ) | `[virtual]`

this function is called in each simulation timestep (always after control).

It should perform robot-internal checks and actions like resetting certain sensors or implement velocity dependend friction and the like. The attached Motors should act here.

Parameters:

  | globalData | structure that contains global data from the simulation environment

Reimplemented from OdeRobot.

static RobotChainConf getDefaultConf | ( |  | ) | `[inline, static]`

int getIRSensorNum | ( |  | ) | `[virtual]`

Primitive * getMainPrimitive | ( |  | ) | const`[protected, virtual]`

return the primitive of the robot that is used for tracking and camera following

Reimplemented from OdeRobot.

int getMotorNumber | ( |  | ) | `[virtual]`

returns number of motors

Implements AbstractRobot.

int getSensorNumber | ( |  | ) | `[virtual]`

returns number of sensors

Implements AbstractRobot.

int getSensors | ( | sensor * | sensors,
|  | int | sensornumber |
| ) |  |  | `[virtual]`

returns actual sensorvalues

Parameters:

  | sensors | sensors scaled to [-1,1]
  | sensornumber | length of the sensor array

Returns:
  number of actually written sensors

Implements AbstractRobot.

void notifyOnChange | ( | const paramkey & | key | ) | `[virtual]`

Is called when a parameter was changes via setParam().

Note that it is not called of parameters of childs are changed, then there notifyOnChange() method is called. The key and of the changed parameter (use getParam() to retrieve its actual value). Overload this function when special actions have to be taken on parameter changes.

Reimplemented from Configurable.

void place | ( | const osg::Matrix & | pose | ) | `[virtual]`

sets the pose of the vehicle

Parameters:

  | pose | desired pose matrix

Implements OdeRobot.

void setMotors | ( | const motor * | motors,
|  | int | motornumber |
| ) |  |  | `[virtual]`

sets actual motorcommands

Parameters:

  | motors | motors scaled to [-1,1]
  | motornumber | length of the motor array

Implements AbstractRobot.

void update | ( |  | ) | `[virtual]`

updates the OSG nodes of the vehicle

Implements OdeRobot.

## Member Data Documentation

RobotChainConf conf`[protected]`

bool created`[protected]`

std::vector<OdeRobot*> robots`[protected]`

The documentation for this class was generated from the following files:

- robotchain.h
- robotchain.cpp